Triggers = {}

Sounds["tick flapping"].mnemonic = "vend greeting"
Sounds["tick chatter"].mnemonic = "vend purchase"
Sounds["tick falling"].mnemonic = "vend goodbye"
Sounds["tick exploding"].mnemonic = "vend hit"
SceneryTypes["small cylinder"].mnemonic = "vending machine" --Weland 1.4.3 swears up and down that it's a large cylinder; Says it's a "good size", lol

function Triggers.init()
	
	for s in Scenery() do
		s._damageQuota = 50
	end
	
	--Setup for HUD interaction
	Players[0].texture_palette.size = 2
	Players[0].texture_palette.slots[0]:clear()
	Players[0].texture_palette.slots[0].collection = 1
	Players[0].texture_palette.slots[1]:clear()
	Players[0].texture_palette.slots[1].collection = 1
	
	--Also some other stuff
	Players[0]._mode = 0
	Players[0]._menu_selection = 0
	Players[0]._current_vendor = 0
	Players[0]._last_weapon = nil
	Players[0].life = 140
	
	--Keep the player on ice while engaged with vendor
	Players[0]._stasis = {}
	Players[0]._stasis.x = 0
	Players[0]._stasis.y = 0
	Players[0]._stasis.z = 0
	Players[0]._stasis.t = 0
	Players[0]._stasis.s = 0
	
	--Maximum distance to interact with stuff using Lua hax
	Players[0]._reach = 1
	
end



function Triggers.idle()
	
	--Beware not to kill vending machines. They're thermo-nuclear powered, or something
	for s in Scenery() do
		if s._damageQuota < 0 then
			local x, y, z, p = s.x, s.y, s.z, s.polygon
			local oh = Effects.new(s.x, s.y, s.z, s.polygon, "rocket explosion")
			Players[0]:fade_screen("long bright")
			Players[0]:play_sound("juggernaut exploding", 0.1)
			Players[0]:accelerate((Players[0].yaw + 180) % 360, 100000, 0)
			s:delete()
			Players[0]:damage(10000, "lava")
		end
	end
	
	--Keep HUD updated on what we're doing
	Players[0].texture_palette.slots[0].texture_index = Players[0]._mode
	Players[0].texture_palette.slots[1].texture_index = Players[0]._menu_selection

	if Players[0].action_flags.action_trigger then
		if Players[0]._mode == 0 then 
			hitScan()
		else
			Players[0]._mode = 0
			Players[0]._current_vendor:play_sound("vend goodbye")
			Players[0].weapons.active = true
			if Players[0]._last_weapon then
				Players[0].weapons[Players[0]._last_weapon]:select()
			end
		end
	end
	  
	--Vending behaviors
	if Players[0]._mode == 1 then

		Players[0].weapons.active = false

		--Cycle weapons back/forwards to select over the menu
		if Players[0].action_flags.cycle_weapons_forward then
			Players[0]._menu_selection = Players[0]._menu_selection + 1;
			if Players[0]._menu_selection > 2 then
				Players[0]._menu_selection = 2
			else
				Players[0]:play_sound("computer page", 1)
			end
		elseif Players[0].action_flags.cycle_weapons_backward then
			Players[0]._menu_selection = Players[0]._menu_selection - 1;
			if Players[0]._menu_selection < 0 then
				Players[0]._menu_selection = 0
			else
				Players[0]:play_sound("computer page", 1)
			end
		end

		--Press M to buy stuff. I guess it's an alternate action key now, huh?
		if Players[0].action_flags.toggle_map then
		vendPurchase()
		end

		--Try not squirming around so much...
		stasisLock()
		
	end
  
end



function Triggers.projectile_detonated(type, owner, polygon, x, y, z)
	
	-- Check to see if somebody hit a vending machine...
	for s in Scenery() do
		if s.type == "vending machine" then
			if math.abs(s.x - x) < 1 and math.abs(s.y - y) < 1 and math.abs(s.z - z) < 1 then
				s:play_sound("vend hit")
				s._damageQuota = s._damageQuota - 10
			end
		end
	end
	
end



function distanceToPlayer(t, p)
	local x = math.abs(t.x - p.x)
	local y = math.abs(t.y - p.y)
	local z = math.abs(t.z - p.z)
	local a = math.sqrt(x^2 + y^2)
	return math.sqrt(a^2 + z^2)
end


function hitScan()
	local t, x, y, z, p = Players[0]:find_target()
	if is_scenery(t) then
		sceneryDo(t)
	end
end


function stasisInit()
	Players[0]._stasis.x = Players[0].x
	Players[0]._stasis.y = Players[0].y
	Players[0]._stasis.z = Players[0].z
	Players[0]._stasis.s = Players[0].yaw
	Players[0]._stasis.t = Players[0].pitch
	Players[0]._stasis.u = Players[0].polygon
end


function stasisLock()
	Players[0]:position(Players[0]._stasis.x, Players[0]._stasis.y, Players[0]._stasis.z, Players[0]._stasis.u)
	Players[0].yaw = Players[0]._stasis.s
	Players[0].pitch = Players[0]._stasis.t
end


function sceneryDo(s)
	if s.type == "vending machine" then
		if distanceToPlayer(s, Players[0]) < Players[0]._reach then
			vendInit(s)
		end
	end
end


function vendInit(s)
	s:play_sound("vend greeting")
	if Players[0].weapons.current then
		Players[0]._last_weapon = Players[0].weapons.current.type
	end
	Players[0]._current_vendor = s
	stasisInit()
	Players[0]._mode = 1
end


function vendPurchase()
	if Players[0]._menu_selection == 0 and Players[0].life < 150 then
		Players[0].items["single health"] = Players[0].items["single health"] + 1
		Players[0]._current_vendor:play_sound("vend purchase")
	elseif Players[0]._menu_selection == 1 and Players[0].life < 300 then
		Players[0].items["double health"] = Players[0].items["double health"] + 1
		Players[0]._current_vendor:play_sound("vend purchase")
	elseif Players[0]._menu_selection == 2 and Players[0].life < 450 then
		Players[0].items["triple health"] = Players[0].items["triple health"] + 1
		Players[0]._current_vendor:play_sound("vend purchase")
	end
end

